package ru.dbotthepony.kstarbound.client.render

import it.unimi.dsi.fastutil.ints.Int2ObjectFunction
import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap
import it.unimi.dsi.fastutil.objects.Reference2ObjectFunction
import it.unimi.dsi.fastutil.objects.Reference2ObjectOpenHashMap
import ru.dbotthepony.kstarbound.client.gl.vertex.GeometryType
import ru.dbotthepony.kstarbound.client.gl.vertex.VertexBuilder
import java.util.stream.Stream

class MultiMeshBuilder {
	data class Entry(val config: RenderConfig<*>, val builder: VertexBuilder, val layer: Int)

	private val meshes = Reference2ObjectOpenHashMap<RenderConfig<*>, Int2ObjectOpenHashMap<Entry>>()

	fun get(config: RenderConfig<*>, layer: Int): VertexBuilder {
		return meshes.computeIfAbsent(config, Reference2ObjectFunction {
			Int2ObjectOpenHashMap()
		}).computeIfAbsent(layer, Int2ObjectFunction { Entry(config, VertexBuilder(config.program.attributes, GeometryType.QUADS), layer) }).builder
	}

	fun clear() = meshes.clear()
	fun isEmpty() = meshes.isEmpty()
	fun isNotEmpty() = meshes.isNotEmpty()

	fun meshes(): Stream<Entry> {
		return meshes.values.stream().flatMap { it.values.stream() }
	}
}
