package ru.dbotthepony.kstarbound.client.render

import ru.dbotthepony.kstarbound.client.gl.GLStateTracker
import ru.dbotthepony.kstarbound.client.gl.shader.GLShaderProgram
import ru.dbotthepony.kvector.arrays.Matrix4f

abstract class RenderConfig<out T : GLShaderProgram>(val state: GLStateTracker, val program: T) {
	open fun setup(transform: Matrix4f = state.matrixStack.last()) {
		program.use()
	}

	open fun uninstall() {}
}
